<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * Acumulus Module for VirtueMart plugin
 */
class plgSystemVmacumulus extends JPlugin
{
	/**
	 * Constructor
	 *
	 * @param object $subject
	 * @param array $config 
	 * @return void
	 */
	
	private function multipleVatPercentages($order_id,$raise_error=true) {
		$db = JFactory::getDBO();
		$prev_tax = null;
		$multiple_tax = false;
		$db->setQuery("SELECT product_item_price,product_tax FROM #__virtuemart_order_items WHERE virtuemart_order_id = ".$db->quote($order_id));
		$result = $db->loadObjectList();

		if(is_array($result)) {
			foreach($result as $row) {
				$tax = (int)round($row->product_tax / $row->product_item_price * 100);
				
				if($tax != $prev_tax && $prev_tax != null) {
					/*AD 2013-6-16 verschillende BTW's niet erg!!*/
					/*voorlopig onderdrukken het signaleren ervan*/
					/*$multiple_tax = true;*/
					$multiple_tax = false;
					break;
				}

				$prev_tax = (int)$tax;


			}
		}
		if($multiple_tax && $raise_error) JFactory::getApplication()->enqueueMessage('<h1>Deze order heeft meerdere BTW types. U dient van deze order handmatig een factuur te maken</h1>', 'error');
		return $multiple_tax;

	}

	public function plgSystemVmacumulus(&$subject, $config)
	{

		parent::__construct($subject, $config);
if(isset($_POST['item_id']) && !empty($_POST['item_id'])){
		$application = JFactory::getApplication();
		if($application->isAdmin()){ 
			$db = JFactory::getDBO();
			$query = "SELECT order_status FROM #__virtuemart_order_items WHERE virtuemart_order_id = '".strip_tags(stripslashes($_POST['virtuemart_order_id']))."'";
			$db->setQuery($query);
			$row = $db->loadAssoc();
			$order_status = $row['order_status'];
			$key = @array_keys($_POST['item_id']);
			$values = @array_values($_POST);
			$order_status_send = @array_values($values[0]);
			
					if ( $order_status_send[0]['order_status'] != $order_status ) {
	
						if($order_status_send[0]['order_status'] == 'C'){
						
						if(!require_once(JPATH_BASE . '/../modules/mod_virtuemart_acumulus/mod_virtuemart_acumulus.php')){
							
							die('cant include acumulus module');
							
						}


						if(!$this->multipleVatPercentages($_POST['virtuemart_order_id'])) $acumulus = new mod_virtuemart_acumulus($_POST, $key);
					}
	
	
					}
		}	
}elseif($_POST['orders'] && is_array($_POST['orders'])){	
		
		$application = JFactory::getApplication();
		if($application->isAdmin()){ 

				$orderslist = JRequest::getVar('orders',  array());
			foreach ($orderslist as $key => $order) {
				if ( $orderslist[$key]['order_status'] !== $orderslist[$key]['current_order_status'] ) {

					if($orderslist[$key]['order_status'] == 'C'){
					
					if(!require_once(JPATH_BASE . '/../modules/mod_virtuemart_acumulus/mod_virtuemart_acumulus.php')){
						
						die('cant include acumulus module');
						
					}
					if(!$this->multipleVatPercentages($key)) $acumulus = new mod_virtuemart_acumulus($_POST, $key);
				}


				}
			}

			}
	}elseif($_POST['virtuemart_order_id'] && !empty($_POST['virtuemart_order_id'])){
		$application = JFactory::getApplication();
		if($application->isAdmin()){ 
		
				if ( $_POST['order_status'] !== $_POST['current_order_status'] ) {

					if($_POST['order_status'] == 'C'){
					
					if(!require_once(JPATH_BASE . '/../modules/mod_virtuemart_acumulus/mod_virtuemart_acumulus.php')){
						
						die('cant include acumulus module');
						
					}
					if(!$this->multipleVatPercentages($_POST['virtuemart_order_id'])) $acumulus = new mod_virtuemart_acumulus($_POST, $_POST['virtuemart_order_id']);
				}


				}

		
		}
	}
	}
}

?>